unit DND_Global;

interface

uses OpenGL15,Cam,Math3d,Q3BSP,NewtonImport,DND_Newton_Vehicle;

var
SCREEN_WIDTH,SCREEN_HEIGHT : Integer;
FOV,DEPTH_OF_VIEW : Single;
h_DC : Integer;

Camera : TCamera;

//Misc
TestCollision       : Boolean;
pause               : Boolean;
UseCameraByMouse    : Boolean = false;
ShowNewtonCollision : Boolean;

//Keys
lastKeyPress : cardinal;
keys : array[0..255] of Boolean;   // Holds keystrokes

//Player
Player_Stand,Player_Crouch,Player_Box : TVector4f;
MatPlayer      : Cardinal;
PlayerListID   : Cardinal;
PlayerBody     : PNewtonBody;
PlayerMatrix   : TMatrix4f;
PlayerPosition : TVector3f;
CanJump        : Boolean;
PlayerVelocity : TVector3f;

//Q3BSP
Q3Loaded    : Boolean;
Q3Level     : TQuake3BSP;
CollTreeBSP : PNewtonCollision; // Collision Tree for the Level
BodyBSP     : PNewtonBody;

//Newton
NewtonWorld        : PNewtonWorld;
MatWorld           : Integer;
MatWater           : Integer;
NewtonLoaded       : Boolean;
UserData           : Pointer;
NewtonTexID        : Cardinal;
Collider           : PNewtonCollision;

//Vehicle
Vehicle            : TNewtonVehicle;
TireMatrix         : TMatrix4f;
MatVehicle         : Integer;

InVehicle          : Boolean = false;


Const
//Speeds
Run_Speed = 200;
Walk_Speed = 100;
Crouch_Speed = 40;

function StrToFloat(s : string) : extended;
function StrToInt(s : string) : integer;

implementation

uses sysutils;

function StrToFloat(s : string) : extended;
begin
  try
   // s := StringReplace(s, '.', ',', [rfReplaceAll]);
    result := sysutils.StrToFloat(s);
  except
  Try
    s := StringReplace(s, '.', ',', [rfReplaceAll]);
    result := sysutils.StrToFloat(s);
  except
    result := 0.0;
  end;
  end;
end;

function StrToInt(s : string) : integer;
begin
  try
    result := sysutils.StrToInt(s);
  except
    result := 0;
  end;
end;

Begin
FOV := 45;
DEPTH_OF_VIEW := 4000;
TestCollision := False;

Player_Stand := SetVector4f(8, 45, 8,22.5);
Player_Crouch := SetVector4f(8, 16, 8,8);
Player_Box := Player_Stand;
end.
